function params = parse_inputs(params, varargin)
%PARSE_INPUTS - parses input arguments specified as 'argument', value
%  pairs.  p=PARSE_INPUTS(params,'a', 1, 'b', 2') will return a the structure
%
%    p.a = 1
%    p.b = 2
%
%  params specifies the initial parameters (e.g the defaults)
%
%Ian Atkinson - 2004

%==========================================================================
%== Revision History ======================================================
%==========================================================================
% Date     | Author | Description 
%--------------------------------------------------------------------------
% 10.23.04 | IA     | Original write 
%--------------------------------------------------------------------------


    if(isempty(params))
        params = struct;
    end


    % look for parameters, they should come in 2-puls
    for i=2:2:length(varargin)
        param = varargin{i-1};
        value = varargin{i};
        
        eval(['params.' param  ' = value;']);        
    end

